#include "sokodan.h"
#include "PositionX.h"
#include "PosListX.h"

/*
  +----------------------------------------------------------------------------
  | NAME:     PosList_new
  | PURPOSE:  Creates an empty list of positions.
  | INPUT:    None.
  | OUTPUT:   A new, empty list of positions.
  | NOTES:    :)
  +----------------------------------------------------------------------------
*/
PosList PosList_new (void)
{
	return NULL;
}

/*
  +----------------------------------------------------------------------------
  | NAME:     PosList_delete
  | PURPOSE:  Frees all the positions in the list, and frees the list itself.
  | INPUT:    A PosList.
  | OUTPUT:   None.
  | NOTES:    The positions are NOT freed, since they have not been allocated
  |           or duplicated in PosList_add_Position().
  +----------------------------------------------------------------------------
*/
void PosList_delete (PosList pl)
{
  g_slist_free (pl);
}

/*
  +----------------------------------------------------------------------------
  | NAME:     PosList_add_Position
  | PURPOSE:  Add a position to the list of positions.
  | INPUT:    A pointer to a PosList and a pointer to a position.
  | OUTPUT:   None.
  | NOTES:    The position is not duplicated before being added to the list,
  |           thus the position can NOT be a local variable.
  +----------------------------------------------------------------------------
*/
void PosList_add_Position (PosList          *pl,
													 const PositionPtr pos)
{
	*pl = g_slist_prepend (*pl, pos);
}
