#include "sokodan.h"
#include <gtk/gtk.h>

static GtkWidget *Gui_About = NULL;

static void gui_about_close (GtkWidget *wid)
{
  gtk_widget_hide (Gui_About);
}

#if USE_GNOME
#include <gnome.h>

void gui_about_show (void)
{
  const gchar *authors[] = {
    "Daniel Dchelotte",
    NULL
  };
  if (Gui_About == NULL)
  {
    Gui_About = gnome_about_new (PACKAGE, VERSION,
                                 "(c) 1999-2002 Daniel Dchelotte",
                                 authors,
                                 _("Clairement, la rsolution des problmes de sokoban n'tait qu'un prtexte."),
                                 NULL);
    
    gtk_window_set_modal (GTK_WINDOW (Gui_About), TRUE);

    gtk_signal_connect (GTK_OBJECT (Gui_About), "close",
                        GTK_SIGNAL_FUNC (gui_about_close),
                        NULL);
  }

  gtk_widget_show (Gui_About);
}

#else /* USE_GNOME */
#include "pixmaps.h"

void gui_about_show (void)
{
  GtkWidget *dlg_frame;
  GtkWidget *vbox_main;
  GtkWidget *hbox;
  GtkWidget *pixmap;
  GtkWidget *label;
  GtkWidget *hseparator;
  GtkWidget *action_area;
  GtkWidget *button;

  if (Gui_About == NULL)
  {
    Gui_About = gtk_window_new (GTK_WINDOW_DIALOG);
    gtk_window_set_title (GTK_WINDOW (Gui_About), _(" propos de sokoDan"));
    gtk_window_set_modal (GTK_WINDOW (Gui_About), TRUE);
    gtk_window_set_policy (GTK_WINDOW (Gui_About), FALSE, FALSE, FALSE);

    dlg_frame = gtk_frame_new (NULL);
    gtk_container_add (GTK_CONTAINER (Gui_About), dlg_frame);
    gtk_frame_set_shadow_type (GTK_FRAME (dlg_frame), GTK_SHADOW_OUT);

    vbox_main = gtk_vbox_new (FALSE, 10);
    gtk_container_add (GTK_CONTAINER (dlg_frame), vbox_main);
    gtk_container_set_border_width (GTK_CONTAINER (vbox_main), 5);

    hbox = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (vbox_main), hbox, TRUE, TRUE, 0);

    pixmap = gtk_pixmap_new (Dialog_Pixmap[ DLG_FISH ], Dialog_Mask[ DLG_FISH ]);
    gtk_box_pack_start (GTK_BOX (hbox), pixmap, FALSE, TRUE, 0);

    label = gtk_label_new (_("Copyright (c) 1999-2002 Daniel Dchelotte"));
    gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
    gtk_misc_set_padding (GTK_MISC (label), 10, 10);

    hseparator = gtk_hseparator_new ();
    gtk_box_pack_start (GTK_BOX (vbox_main), hseparator, FALSE, TRUE, 0);

    action_area = gtk_hbutton_box_new ();
    gtk_box_pack_start (GTK_BOX (vbox_main), action_area, FALSE, TRUE, 0);
    gtk_button_box_set_layout (GTK_BUTTON_BOX (action_area), GTK_BUTTONBOX_END);
    gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (action_area), 7, 2);

    button = gtk_button_new_with_label (_("Glyph"));
    gtk_container_add (GTK_CONTAINER (action_area), button);
    gtk_widget_grab_focus (button);
  
    gtk_signal_connect (GTK_OBJECT (Gui_About), "delete_event",
                        GTK_SIGNAL_FUNC (gui_about_close),
                        Gui_About);
    gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
                               GTK_SIGNAL_FUNC (gui_about_close),
                               GTK_OBJECT (Gui_About));
  }

  gtk_widget_show_all (Gui_About);
}

#endif /* USE_GNOME */
