#include "sokodan.h"
#include <gtk/gtk.h>

#if USE_GNOME
#include <gnome.h>

void gui_info_show (char *title, char *message)
{
  GtkWidget *gui_info;

  gui_info = gnome_message_box_new (message, 
                                    GNOME_MESSAGE_BOX_WARNING, NULL);
  gtk_window_set_title (GTK_WINDOW (gui_info), title);
  gtk_window_set_modal (GTK_WINDOW (gui_info), TRUE);
  gtk_window_set_policy (GTK_WINDOW (gui_info), FALSE, FALSE, FALSE);

  gnome_dialog_append_button (GNOME_DIALOG (gui_info), 
                              GNOME_STOCK_BUTTON_OK);

  gtk_widget_show (gui_info);
}

#else /* USE_GNOME */
#include "pixmaps.h"

void gui_info_show (char *title, char *message)
{
  GtkWidget *gui_info;
  GtkWidget *dlg_frame;
  GtkWidget *vbox_main;
  GtkWidget *hbox;
  GtkWidget *pixmap;
  GtkWidget *label;
  GtkWidget *hseparator;
  GtkWidget *action_area;
  GtkWidget *button;

  gui_info = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (gui_info), title);
  gtk_window_set_modal (GTK_WINDOW (gui_info), TRUE);
  gtk_window_set_policy (GTK_WINDOW (gui_info), FALSE, FALSE, FALSE);

  dlg_frame = gtk_frame_new (NULL);
  gtk_container_add (GTK_CONTAINER (gui_info), dlg_frame);
  gtk_frame_set_shadow_type (GTK_FRAME (dlg_frame), GTK_SHADOW_OUT);

  vbox_main = gtk_vbox_new (FALSE, 10);
  gtk_container_add (GTK_CONTAINER (dlg_frame), vbox_main);
  gtk_container_set_border_width (GTK_CONTAINER (vbox_main), 5);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_main), hbox, TRUE, TRUE, 0);

  pixmap = gtk_pixmap_new (Dialog_Pixmap[ DLG_HAND ], Dialog_Mask[ DLG_HAND ]);
  gtk_box_pack_start (GTK_BOX (hbox), pixmap, FALSE, TRUE, 0);

  label = gtk_label_new (message);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
  gtk_misc_set_padding (GTK_MISC (label), 10, 10);

  hseparator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (vbox_main), hseparator, FALSE, TRUE, 0);

  action_area = gtk_hbutton_box_new ();
  gtk_box_pack_start (GTK_BOX (vbox_main), action_area, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (action_area), GTK_BUTTONBOX_END);
  gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (action_area), 7, 2);

  button = gtk_button_new_with_label (_("Bon sang !"));
  gtk_container_add (GTK_CONTAINER (action_area), button);
  gtk_widget_grab_focus (button);
  
  gtk_signal_connect (GTK_OBJECT (gui_info), "delete_event",
                      GTK_SIGNAL_FUNC (gtk_widget_destroy),
                      gui_info);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (gui_info));

  gtk_widget_show_all (gui_info);
}

#endif /* USE_GNOME */
