#include "sokodan.h"
#include <gtk/gtk.h>
#if USE_GNOME
# include <gnome.h>
#endif
#include "pixmaps.h"
#include "PositionX.h"
#include "MoveX.h"
#include "guix.h"

const delta Delta[ 4 ] =
{
  { 0,  1}, /* DOWN  */
  { 1,  0}, /* RIGHT */
  { 0, -1}, /* UP    */
  {-1,  0}  /* LEFT  */
};

Position Problem;
tSolution Solution;

int main (gint argc, gchar *argv[])
{
  Coordinate x, y;

  /* Initialize gettext and locales */
  setlocale (LC_MESSAGES, "");
  bindtextdomain (PACKAGE, SOKODAN_LOCALE_DIR);
  textdomain (PACKAGE);

  /* Initialize POSIX threads */
  g_thread_init (NULL);
  if (!g_thread_supported ())  g_error ("Threads not supported. Aborting...\n");

  /* Initialize GTK+ or GNOME */
#if USE_GNOME
  gnome_init ("sokoDan", VERSION, argc, argv);
#else
  gtk_init (&argc, &argv);
#endif

  /* Initialize the memory chunks */
	Move_init ();
  Position_init ();

  /* Initialize the problem */
  for  (x = 0; x < WIDTH; x++)
    for  (y = 0; y < HEIGHT; y++)
      Problem.grid[ x ][ y ] = BACKGROUND;

  Problem.player_x = WIDTH;  /* Impossible x */
  Problem.player_y = HEIGHT; /* Impossible y */

  /* Creates the GdkPixmap's */
  pixmaps_init ();

  /* Create the pb gui and show it */
  gui_main_show ();

  /* Wait for the fun to begin! */
  gdk_threads_enter ();
  gtk_main ();
  gdk_threads_leave ();

  return 0;
}
