#ifndef _TYPES_H_
#define _TYPES_H_


typedef guchar Case;
typedef guint8 Coordinate;

typedef enum 
{
	DOWN  = 0,
	RIGHT = 1,
	UP    = 2,
	LEFT  = 3
} Direction;

typedef struct { gint8 dx, dy; } delta;


typedef struct position
{
	Case             grid[ WIDTH ][ HEIGHT ];
	Coordinate       player_x, player_y; /* really keep that ? */
	guint            hash_value;
  struct position *previous;
} Position, *PositionPtr;

typedef GSList*   PosList;


typedef struct move
{
	Coordinate  x, y;
	Direction   dir;
} Move, *MovePtr;

typedef GSList* MoveList;

typedef GHashTable* PosHashTable;


#endif /* _TYPES_H_ */
